/*============================================================================
  File:     HackAttachLogBackupSetup.sql

  Summary:  This script sets up for the hack-attach log
			tail backup demo.

  Date:     June 2010

  SQL Server Versions:
		10.0.2531.00 (SS2008 SP1)
		9.00.4035.00 (SS2005 SP3)
------------------------------------------------------------------------------
  Written by Paul S. Randal, SQLskills.com

  (c) 2011, SQLskills.com. All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you include this copyright and give due
  credit, but you must obtain prior permission before blogging this code.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

USE master;
GO

IF DATABASEPROPERTYEX ('DBMaint2008', 'Version') > 0
	DROP DATABASE DBMaint2008;
GO

-- Create a database
CREATE DATABASE DBMaint2008;
GO

USE DBMaint2008;
GO

CREATE TABLE TestTable (
	C1 INT IDENTITY,
	C2 CHAR (100));
GO

-- Take a full backup
BACKUP DATABASE DBMaint2008 TO
	DISK = 'D:\SQLskills\DemoBackups\DBMaint_Full_HAD.bck'
	WITH INIT;
GO

-- Insert some rows
INSERT INTO TestTable VALUES (
	'Transaction 1');
INSERT INTO TestTable VALUES (
	'Transaction 2');

-- Take a log backup
BACKUP LOG DBMaint2008 TO
	DISK = 'D:\SQLskills\DemoBackups\DBMaint_Log1_HAD.bck'
	WITH INIT;
GO

-- Insert some more rows
INSERT INTO TestTable VALUES (
	'Transaction 3');
INSERT INTO TestTable VALUES (
	'Transaction 4');
GO
	
-- Take the database offline
ALTER DATABASE DBMaint2008 SET OFFLINE;
GO

-- Copy off the log file and delete the data

-- Now delete the database completely
DROP DATABASE DBMaint2008;
GO