/*============================================================================
  File:     SetupSystemTableIndexCorruption.sql

  Summary:  This script creates DemoSystemNCIndex, with
			system table NC index corruption

  Date:     April 2011

  SQL Server Versions:
		10.0.2531.00 (SS2008 SP1)
------------------------------------------------------------------------------
  Written by Paul S. Randal, SQLskills.com

  (c) 2011, SQLskills.com. All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you include this copyright and give due
  credit, but you must obtain prior permission before blogging this code.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

USE master;
GO
/* If the DemoSystemIndex1.bak doesn't exist...

RESTORE DATABASE DemoSystemIndex1 FROM DISK =
	'C:\SQLskills\SalesDBOriginal.bak'
WITH MOVE 'SalesDBData' TO
	'D:\SQLskills\DemoSystemIndex1.mdf',
MOVE 'SalesDBLog' TO
	'D:\SQLskills\DemoSystemIndex1_LOG.ldf',
REPLACE;
GO

RESTORE DATABASE DemoSystemIndex2 FROM DISK =
	'C:\SQLskills\SalesDBOriginal.bak'
WITH MOVE 'SalesDBData' TO
	'D:\SQLskills\DemoSystemIndex2.mdf',
MOVE 'SalesDBLog' TO
	'D:\SQLskills\DemoSystemIndex2_LOG.ldf',
REPLACE;
GO

RESTORE DATABASE DemoSystemIndex3 FROM DISK =
	'C:\SQLskills\SalesDBOriginal.bak'
WITH MOVE 'SalesDBData' TO
	'D:\SQLskills\DemoSystemIndex3.mdf',
MOVE 'SalesDBLog' TO
	'D:\SQLskills\DemoSystemIndex3_LOG.ldf',
REPLACE;
GO

RESTORE DATABASE DemoSystemIndex4 FROM DISK =
	'C:\SQLskills\SalesDBOriginal.bak'
WITH MOVE 'SalesDBData' TO
	'D:\SQLskills\DemoSystemIndex4.mdf',
MOVE 'SalesDBLog' TO
	'D:\SQLskills\DemoSystemIndex4_LOG.ldf',
REPLACE;
GO
*/

/*
USE DemoSystemIndex1;
GO

EXEC sp_AllocationMetadata 'sys.sysallocunits';
GO
-- First 24480, root 24480 for NC 2
*/
-- Corrupt the name of slot 2

-- corrupt page 24480 at offset 96 bytes with 4 bytes of zeroes

BACKUP DATABASE DemoSystemIndex1 TO
	DISK = 'D:\SQLskills\CorruptionDemoBackups\CorruptDemoSystemIndex1.bak'
WITH INIT;
GO


/*
USE DemoSystemIndex2;
GO

EXEC sp_AllocationMetadata 'sys.sysallocunits';
GO
-- Root 55 for clustered
*/

-- Corrupt page 55 at offset 96 bytes with 4 bytes of zeroes

BACKUP DATABASE DemoSystemIndex2 TO
	DISK = 'D:\SQLskills\CorruptionDemoBackups\CorruptDemoSystemIndex2.bak'
WITH INIT;
GO

/*
USE DemoSystemIndex3;
GO

EXEC sp_AllocationMetadata 'sys.syscolpars';
GO
-- Root 11 for clustered
*/

-- Corrupt page 111 at offset 96 bytes with 4 bytes of zeroes

BACKUP DATABASE DemoSystemIndex3 TO
	DISK = 'D:\SQLskills\CorruptionDemoBackups\CorruptDemoSystemIndex3.bak'
WITH INIT;
GO

/*
USE DemoSystemIndex4;
GO

SELECT name FROM sys.objects;
GO

EXEC sp_AllocationMetadata 'sys.sysidxstats';
GO
-- Root 40 for clustered
*/

-- Corrupt page 40 at offset 96 bytes with 4 bytes of zeroes

BACKUP DATABASE DemoSystemIndex4 TO
	DISK = 'D:\SQLskills\CorruptionDemoBackups\CorruptDemoSystemIndex4.bak'
WITH INIT;
GO

